Index: TOOLS/WATER_BUDGET/ATM_waterbudget.py
===================================================================
--- TOOLS/WATER_BUDGET/ATM_waterbudget.py	(revision 6446)
+++ TOOLS/WATER_BUDGET/ATM_waterbudget.py	(revision 6508)
@@ -1044,18 +1261,23 @@
 prtFlux ('coastal   ', RUN_flx_coastal     , 'f' ) 
 prtFlux ('riv+coa   ', RUN_flx_fromrouting , 'f' ) 
-prtFlux ('budget    ', RUN_flx_all         , 'f' , True)
+prtFlux ('budget    ', RUN_flx_all         , 'f' , small=True)
+
+echo ( '\n------------------------------------------------------------------------------------' )
+echo ( f'Water content in routing+lake  -- {Title} ' )
+echo ( f'RUN_mas_wat_beg  = {RUN_mas_wat_beg:12.6e} kg | RUN_mas_wat_end = {RUN_mas_wat_end:12.6e} kg ' )
+prtFlux ( 'dMass (routing)  ', dRUN_mas_wat+dSRF_mas_lake, 'f', small=True)
+prtFlux ( 'Routing error    ', RUN_flx_all+dSRF_mas_lake-dRUN_mas_wat, 'e', small=True )
+echo ( 'Routing error : {:12.3e} (rel)'.format ( (RUN_flx_all-dSRF_mas_lake-dRUN_mas_wat)/(dRUN_mas_wat+dSRF_mas_lake) ) )
 
 echo ( '\n------------------------------------------------------------------------------------' )
 echo ( f'Water content in routing  -- {Title} ' )
-echo ( 'RUN_mas_wat_beg  = {:12.6e} kg | RUN_mas_wat_end = {:12.6e} kg '.format (RUN_mas_wat_beg, RUN_mas_wat_end) )
-prtFlux ( 'dMass (routing)  ', dRUN_mas_wat+dSRF_mas_lake, 'f', True)
-
-echo ( '\n------------------------------------------------------------------------------------' )
-echo ( f'Water content in routing  -- {Title} ' )
-echo ( 'RUN_mas_wat_beg  = {:12.6e} kg | RUN_mas_wat_end = {:12.6e} kg '.format (RUN_mas_wat_beg, RUN_mas_wat_end) )
-prtFlux ( 'dMass (routing)  ', dRUN_mas_wat, 'f', True  )
-
-print ( 'Routing error : {:12.3e} (rel)'.format ( (RUN_flx_all-dRUN_mas_wat)/dRUN_mas_wat ) )
+echo ( f'RUN_mas_wat_beg  = {RUN_mas_wat_beg:12.6e} kg | RUN_mas_wat_end = {RUN_mas_wat_end:12.6e} kg ' )
+prtFlux ( 'dMass (routing) ', dRUN_mas_wat, 'f', small=True  )
+prtFlux ( 'Routing error   ', RUN_flx_all-dRUN_mas_wat, 'e', small=True)
+echo ( 'Routing error : {:12.3e} (rel)'.format ( (RUN_flx_all-dRUN_mas_wat)/dRUN_mas_wat ) )
 
 # PRINT *,"routing water Balance ;  before : ",Â water_balance_before," ; after : ",water_balance_after,  &a
 # 1150	            " ; delta : ",Â 100*(water_balance_after-water_balance_before)/(0.5*(water_balance_after+water_balance_before)),"%"
+
+echo ( ' ' )
+echo ( f'{Title = }' )
Index: TOOLS/WATER_BUDGET/CPL_waterbudget.py
===================================================================
--- TOOLS/WATER_BUDGET/CPL_waterbudget.py	(revision 6446)
+++ TOOLS/WATER_BUDGET/CPL_waterbudget.py	(revision 6508)
@@ -22,155 +22,180 @@
 ###
 ## Import system modules
-import sys, os, shutil, subprocess
+import sys, os, shutil, subprocess, platform
 import numpy as np
 import configparser, re
-
-## Creates parser
-config = configparser.ConfigParser()
+from pathlib import Path
+
+# Check python version
+if sys.version_info < (3, 8, 0) :
+    print ( f'Python version : {platform.python_version()}' ) 
+    raise Exception ( "Minimum Python version is 3.8" )
+
+## Import local module
+import WaterUtils as wu
+
+## Creates parser for reading .ini input file
+config = configparser.ConfigParser (interpolation=configparser.ExtendedInterpolation() )
 config.optionxform = str # To keep capitals
 
-config['Files']  = {}
-config['System'] = {}
-
-##-- Some physical constants
-#-- Earth Radius
-Ra = 6366197.7236758135
-#-- Gravity
-grav = 9.81
-#-- Ice volumic mass (kg/m3) in LIM3/SI3
-ICE_rho_ice = 917.0
-#-- Snow volumic mass (kg/m3) in LIM3/SI3
-ICE_rho_sno = 330.0
-#-- Water in ponds coluclic mass (kg/m3) in LIM3/SI3
-ICE_rho_pnd = 1000.
-#-- Ocean water volumic mass (kg/m3) in NEMO
-OCE_rho_liq = 1026.
-#-- Water volumic mass in atmosphere
-ATM_rho = 1.0e3
-#-- Water volumic mass in surface reservoirs
-SRF_rho = 1.0e3
-#-- Water volumic mass of rivers
-RUN_rho = 1.0e3
-
-## Read experiment parameters
-ATM = None ; ORCA = None ; NEMO = None ; OCE_relax = False ; OCE_icb = False ; Coupled = False ; Routing = None
-
-# Arguments passed
+## Experiment parameters
+ATM=None ; ATM_HIS='latlon' ; SRF_HIS='latlon' ; ORCA=None ; NEMO=None ; OCE_relax=False ; OCE_icb=False ; Coupled=False ; Routing=None ;  TarRestartPeriod_beg=None ; TarRestartPeriod_end=None ; Comment=None ; Period=None ; Title=None
+
+##
+ARCHIVE=None ; STORAGE=None ; SCRATCHDIR=None ; R_IN=None ; rebuild=None
+TmpDir=None ; RunDir=None ; FileOut=None ; dir_ATM_his=None ; dir_SRF_his=None ; dir_OCE_his=None ; dir_ICE_his=None ; FileCommon=None
+file_ATM_his=None ; file_SRF_his=None ; file_RUN_his=None ; file_OCE_his=None ;  file_ICE_his=None ; file_OCE_sca=None
+tar_restart_beg=None ; tar_restart_end=None ; file_ATM_beg=None ; file_ATM_end=None ; file_DYN_beg=None ; file_DYN_end=None ; file_SRF_beg=None ; file_SRF_end=None
+file_RUN_beg=None ; file_RUN_end=None ; file_RUN_end=None ; file_OCE_beg=None ; file_ICE_beg=None ; file_OCE_beg=None ; file_OCE_end=None ; file_OCE_srf=None ; file_OCE_sca=None ; file_ICE_beg=None ; file_OCE_end=None ; file_ICE_end=None
+
+# Read command line arguments
 print ( "Name of Python script:", sys.argv[0] )
-IniFile =  sys.argv[1]
+IniFile = sys.argv[1]
+# Text existence of IniFile
+if not os.path.exists (IniFile ) :
+    raise FileExistsError ( f"File not found : {IniFile = }" )
+
+if 'full' in IniFile : FullIniFile = IniFile
+else                 : FullIniFile = 'full_' + IniFile
+    
 print ("Input file : ", IniFile )
 config.read (IniFile)
-
-def setBool (chars) :
-    '''Convert specific char string in boolean if possible'''
-    setBool = chars
-    for key in configparser.ConfigParser.BOOLEAN_STATES.keys () :
-        if chars.lower() == key : setBool = configparser.ConfigParser.BOOLEAN_STATES[key]
-    return setBool
-
-def setNum (chars) :
-    '''Convert specific char string in integer or real if possible'''
-    if type (chars) == str :
-        realnum = re.compile ("^[-+]?[0-9]*\.?[0-9]+(e[-+]?[0-9]+)?$")
-        isReal = realnum.match(chars.strip()) != None
-        isInt  = chars.strip().isdigit()
-        if isReal :
-            if isInt : setNum = int   (chars)
-            else     : setNum = float (chars)
-        else : setNum = chars
-    else : setNum = chars
-    return setNum
-
-print ('[Experiment]')
-for VarName in config['Experiment'].keys() :
-    locals()[VarName] = config['Experiment'][VarName]
-    locals()[VarName] = setBool (locals()[VarName])
-    locals()[VarName] = setNum  (locals()[VarName])
-    print ( '{:25} set to : {:}'.format (VarName, locals()[VarName]) )
-    
-###
-ICO  = ( 'ICO' in ATM )
-LMDZ = ( 'LMD' in ATM )
-    
-###
-## Import system modules
-import sys, os, shutil, subprocess
-
-# Where do we run ?
-SysName, NodeName, Release, Version, Machine = os.uname()
-TGCC  = ( 'irene'   in NodeName )
-IDRIS = ( 'jeanzay' in NodeName )
-
-## Set site specific libIGCM directories, and other specific stuff
-if TGCC :
-    CPU = subprocess.getoutput ( 'lscpu | grep "Model name"' )
-    if "Intel(R) Xeon(R) Platinum" in CPU : Machine = 'irene'
-    if "AMD"                       in CPU : Machine = 'irene-amd'
-        
-    ARCHIVE     = subprocess.getoutput ( f'ccc_home --cccstore   -d {Project} -u {User}' )
-    STORAGE     = subprocess.getoutput ( f'ccc_home --cccwork    -d {Project} -u {User}' )
-    SCRATCHDIR  = subprocess.getoutput ( f'ccc_home --cccscratch -d {Project} -u {User}' )
-    R_IN        = os.path.join ( subprocess.getoutput ( f'ccc_home --cccwork -d igcmg -u igcmg' ), 'IGCM')
-    rebuild     = os.path.join ( subprocess.getoutput ( f'ccc_home --ccchome -d igcmg -u igcmg' ), 'Tools', Machine, 'rebuild_nemo', 'bin', 'rebuild_nemo' )
-
-    ## Specific to run at TGCC.
-    # Needed before importing a NetCDF library (netCDF4, xarray, cmds, etc ...)
-    import mpi4py
-    mpi4py.rc.initialize = False
-        
-    ## Creates output directory
-    #TmpDir = os.path.join ( subprocess.getoutput ( 'ccc_home --cccscratch' ), f'WATER_{JobName}_{YearBegin}_{YearEnd}' )
-    TmpDir = os.path.join ( '/ccc/scratch/cont003/drf/p86mart', f'WATER_{JobName}_{YearBegin}_{YearEnd}' )
-
-if IDRIS :
-    raise Exception("Pour IDRIS : repertoires et chemins a definir") 
-
-## Import specific module
+FullIniFile = 'full_' + IniFile
+
+## Reading config file
+for Section in ['Experiment', 'libIGCM', 'Files', 'Physics' ] :
+   if Section in config.keys () : 
+        print ( f'Reading [{Section}]' )
+        for VarName in config[Section].keys() :
+            locals()[VarName] = config[Section][VarName]
+            exec ( f'{VarName} = wu.setBool ({VarName})' )
+            exec ( f'{VarName} = wu.setNum  ({VarName})' )
+            exec ( f'{VarName} = wu.setNone ({VarName})' )
+            exec (  f'wu.{VarName} = {VarName}' )
+            print ( '{:25} set to : {:}'.format (VarName, locals()[VarName]) )
+            #exec ( f'del {VarName}' )
+
+#-- Some physical constants
+if wu.unDefined ( 'Ra' )           : Ra          = 6366197.7236758135 #-- Earth Radius (m)
+if wu.unDefined ( 'Grav' )         : Grav        = 9.81               #-- Gravity (m^2/s
+if wu.unDefined ( 'ICE_rho_ice' )  : ICE_rho_ice = 917.0              #-- Ice volumic mass (kg/m3) in LIM3
+if wu.unDefined ( 'ICE_rho_sno')   : ICE_rho_sno = 330.0              #-- Snow volumic mass (kg/m3) in LIM3
+if wu.unDefined ( 'OCE_rho_liq' )  : OCE_rho_liq = 1026.0             #-- Ocean water volumic mass (kg/m3) in NEMO
+if wu.unDefined ( 'ATM_rho' )      : ATM_rho     = 1000.0             #-- Water volumic mass in atmosphere (kg/m^3)
+if wu.unDefined ( 'SRF_rho' )      : SRF_rho     = 1000.0             #-- Water volumic mass in surface reservoir (kg/m^3)
+if wu.unDefined ( 'RUN_rho' )      : RUN_rho     = 1000.0             #-- Water volumic mass of rivers (kg/m^3)
+if wu.unDefined ( 'ICE_rho_pnd' )  : ICE_rho_pnd = 1000.              #-- Water volumic mass in ice ponds (kg/m^3)
+if wu.unDefined ( 'YearLength' )   : YearLength  = 365.25 * 24. * 60. * 60. #-- Year length (s) - Use only to compute drif in approximate unit 
+
+# Set libIGCM and machine dependant values
+if not 'Files' in config.keys() : config['Files'] = {}
+
+config['Physics'] = { 'Ra':Ra, 'Grav':Grav, 'ICE_rho_ice':ICE_rho_ice, 'ICE_rho_sno':ICE_rho_sno, 'OCE_rho_liq':OCE_rho_liq, 'ATM_rho':ATM_rho, 'SRF_rho':SRF_rho, 'RUN_rho':RUN_rho}
+
+## --------------------------
+ICO  = ( 'ICO' in wu.ATM )
+LMDZ = ( 'LMD' in wu.ATM )
+
+with open ('SetLibIGCM.py') as f: exec ( f.read() )
+config['Files']['TmpDir'] = TmpDir
+
+if libIGCM :
+    config['libIGCM'] = {'ARCHIVE':ARCHIVE, 'STORAGE':STORAGE, 'SCRATCHDIR':SCRATCHDIR, 'R_IN':R_IN, 'rebuild':rebuild }
+
+# Import specific module
 import nemo, lmdz
 ## Now import needed scientific modules
 import xarray as xr
     
-# Output file
-FileOut = f'CPL_waterbudget_{JobName}_{YearBegin}_{YearEnd}.out'
+# Output file with water budget diagnostics
+if wu.unDefined ( 'FileOut' ) : FileOut = f'CPL_waterbudget_{JobName}_{YearBegin}_{YearEnd}.out'
+config['Files']['FileOut'] = FileOut
+
 f_out = open ( FileOut, mode = 'w' )
-
-# Function to print to stdout *and* output file
+    
+# Useful functions
+def kg2Sv    (val, rho=ATM_rho) :
+    '''From kg to Sverdrup'''
+    return val/dtime_sec*1.0e-6/rho
+
+def kg2myear (val, rho=ATM_rho) :
+    '''From kg to m/year'''
+    return val/ATM_aire_sea_tot/rho/NbYear
+
+def var2prt (var, small=False, rho=ATM_rho) :
+    if small :  return var , kg2Sv(var, rho=rho)*1000., kg2myear(var, rho=rho)*1000.
+    else     :  return var , kg2Sv(var, rho=rho)      , kg2myear(var, rho=rho)
+
+def prtFlux (Desc, var, Form='F', small=False, rho=ATM_rho, width=15) :
+    if small :
+        if Form in ['f', 'F'] : ff=" {:12.4e} kg | {:12.4f} mSv | {:12.4f} mm/year "
+        if Form in ['e', 'E'] : ff=" {:12.4e} kg | {:12.4e} mSv | {:12.4e} mm/year "
+    else :
+        if Form in ['f', 'F'] : ff=" {:12.4e} kg | {:12.4f} Sv  | {:12.4f} m/year  "
+        if Form in ['e', 'E'] : ff=" {:12.4e} kg | {:12.4e} Sv  | {:12.4e} m/year  "
+    echo ( (' {:>{width}} = ' +ff).format (Desc, *var2prt(var, small, rho=rho), width=width ) )
+    return None
+
 def echo (string, end='\n') :
-    print ( string, end=end  )
+    '''Function to print to stdout *and* output file'''
+    print ( str(string), end=end  )
     sys.stdout.flush ()
-    f_out.write ( string + end )
+    f_out.write ( str(string) + end )
     f_out.flush ()
     return None
     
 ## Set libIGCM directories
-R_OUT       = os.path.join ( ARCHIVE   , 'IGCM_OUT')
-R_BUF       = os.path.join ( SCRATCHDIR, 'IGCM_OUT')
-
-L_EXP = os.path.join (TagName, SpaceName, ExperimentName, JobName)
-R_SAVE      = os.path.join ( R_OUT, L_EXP )
-R_BUFR      = os.path.join ( R_BUF, L_EXP )
-POST_DIR    = os.path.join ( R_BUF, L_EXP, 'Out' )
-REBUILD_DIR = os.path.join ( R_BUF, L_EXP, 'REBUILD' )
-R_BUF_KSH   = os.path.join ( R_BUFR, 'Out' )
-R_FIGR      = os.path.join ( STORAGE, 'IGCM_OUT', L_EXP )
-
-#if os.path.isdir (TmpDir) : shutil.rmtree ( TmpDir )
-if not os.path.isdir (TmpDir) : os.mkdir (TmpDir)
-TmpDirOCE = os.path.join (TmpDir, 'OCE')
-TmpDirICE = os.path.join (TmpDir, 'ICE')
-if not os.path.exists (TmpDirOCE) : os.mkdir (TmpDirOCE )
-if not os.path.exists (TmpDirICE) : os.mkdir (TmpDirICE )
-
-echo ( f'Working in TMPDIR : {TmpDir}' )
-
-echo ( f'\nDealing with {L_EXP}' )
+if wu.unDefined ('R_OUT'      ) : R_OUT       = os.path.join ( ARCHIVE   , 'IGCM_OUT' )
+if wu.unDefined ('R_BUF'      ) : R_BUF       = os.path.join ( SCRATCHDIR, 'IGCM_OUT' )
+if wu.unDefined ('L_EXP'      ) : L_EXP       = os.path.join (TagName, SpaceName, ExperimentName, JobName)
+if wu.unDefined ('R_SAVE'     ) : R_SAVE      = os.path.join ( R_OUT, L_EXP )
+if wu.unDefined ('R_BUFR'     ) : R_BUFR      = os.path.join ( R_BUF, L_EXP )
+if wu.unDefined ('POST_DIR'   ) : POST_DIR    = os.path.join ( R_BUFR, 'Out' )
+if wu.unDefined ('REBUILD_DIR') : REBUILD_DIR = os.path.join ( R_BUFR, 'REBUILD' )
+if wu.unDefined ('R_BUF_KSH'  ) : R_BUF_KSH   = os.path.join ( R_BUFR, 'Out' )
+if wu.unDefined ('R_FIGR'     ) : R_FIGR      = os.path.join ( STORAGE, 'IGCM_OUT', L_EXP )
+
+config['libIGCM'] = { 'R_OUT':R_OUT, 'R_BUF':R_BUF, 'L_EXP':L_EXP, 'R_BUFR':R_BUFR, 'POST_DIR':POST_DIR, 'REBUILD_DIR':REBUILD_DIR, 'R_BUF_KSH':R_BUF_KSH, 'R_FIGR':R_FIGR }
+
+# Set directory to extract filesa
+if RunDir == None : RunDir = os.path.join ( TmpDir, f'WATER_{JobName}_{YearBegin}_{YearEnd}' )
+config['Files']['RunDir'] = RunDir
+
+if not os.path.isdir ( RunDir ) : os.makedirs ( RunDir )
+
+# Set directories to rebuild ocean and ice restart files
+RunDirOCE = os.path.join ( RunDir, 'OCE' )
+RunDirICE = os.path.join ( RunDir, 'ICE' )
+#RunDirATM = os.path.join ( RunDir, 'ATM' )
+#RunDirSRF = os.path.join ( RunDir, 'SRF' )
+#RunDirRUN = os.path.join ( RunDir, 'RUN' )
+#RunDirDYN = os.path.join ( RunDir, 'DYN' )
+if not os.path.exists ( RunDirOCE ) : os.mkdir ( RunDirOCE )
+if not os.path.exists ( RunDirICE ) : os.mkdir ( RunDirICE )
+
+echo (' ')
+echo ( f'JobName   : {JobName}'   )
+echo ( f'Comment   : {Comment}'   )
+echo ( f'TmpDir    : {TmpDir}'    )
+echo ( f'RunDirOCE : {RunDirOCE}' )
+echo ( f'RunDirICE : {RunDirICE}' )
+
+echo ( f'\nDealing with {L_EXP}'  )
 
 #-- Model output directories
 if Freq == "MO" : FreqDir =  os.path.join ('Output' , 'MO' )
 if Freq == "SE" : FreqDir =  os.path.join ('Analyse', 'SE' )
-dir_ATM_his = os.path.join ( R_SAVE, "ATM", FreqDir )
-dir_OCE_his = os.path.join ( R_SAVE, "OCE", FreqDir )
-dir_ICE_his = os.path.join ( R_SAVE, "ICE", FreqDir )
-dir_SRF_his = os.path.join ( R_SAVE, "SRF", FreqDir )
+if dir_ATM_his == None :
+    dir_ATM_his = os.path.join ( R_SAVE, "ATM", FreqDir )
+    config['Files']['dir_ATM_his'] = dir_ATM_his
+if dir_SRF_his == None : 
+    dir_SRF_his = os.path.join ( R_SAVE, "SRF", FreqDir )
+    config['Files']['dir_SRF_his'] = dir_SRF_his
+if dir_OCE_his == None :
+    dir_OCE_his = os.path.join ( R_SAVE, "OCE", FreqDir )
+    config['Files']['dir_OCE_his'] = dir_OCE_his
+if dir_ICE_his == None : 
+    dir_ICE_his = os.path.join ( R_SAVE, "ICE", FreqDir )
+    config['Files']['dir_ICE_his'] = dir_ICE_his
 
 echo ( f'The analysis relies on files from the following model output directories : ' )
@@ -180,15 +205,42 @@
 echo ( f'{dir_SRF_his}' )
 
-#-- Files Names
-if Freq == 'MO' : FileCommon = f'{JobName}_{YearBegin}0101_{YearEnd}1231_1M'
-if Freq == 'SE' : FileCommon = f'{JobName}_SE_{YearBegin}0101_{YearEnd}1231_1M'
+#-- Creates files names
+if Period == None :
+    if Freq == 'MO' : Period = f'{YearBegin}0101_{YearEnd}1231_1M'
+    if Freq == 'SE' : Period = f'SE_{YearBegin}0101_{YearEnd}1231_1M'
+    config['Files']['Period'] = Period
+if FileCommon == None :
+    FileCommon = f'{JobName}_{Period}'
+    config['Files']['FileCommon'] = FileCommon
+
+if Title == None :
+    Title = f'{JobName} : {Freq} : {YearBegin}-01-01 - {YearEnd}-12-31'
+    config['Files']['Title'] = Title
 
 echo ('\nOpen history files' )
-file_ATM_his = os.path.join (  dir_ATM_his, f'{FileCommon}_histmth.nc' )
-file_OCE_his = os.path.join (  dir_OCE_his, f'{FileCommon}_grid_T.nc' )
-file_OCE_sca = os.path.join (  dir_OCE_his, f'{FileCommon}_scalar.nc' )
-file_ICE_his = os.path.join (  dir_ICE_his, f'{FileCommon}_icemod.nc' )
-file_SRF_his = os.path.join (  dir_SRF_his, f'{FileCommon}_sechiba_history.nc' )
-file_OCE_srf = os.path.join (  dir_OCE_his, f'{FileCommon}_grid_T.nc' )
+if file_ATM_his == None : 
+    file_ATM_his = os.path.join (  dir_ATM_his, f'{FileCommon}_histmth.nc' )
+    config['Files']['file_ATM_his'] = file_ATM_his
+if file_SRF_his == None :
+    file_SRF_his = os.path.join (  dir_SRF_his, f'{FileCommon}_sechiba_history.nc' )
+    config['Files']['file_SRF_his'] = file_SRF_his
+#if Routing == 'SECHIBA'  :
+#     file_RUN_his = os.path.join (  dir_SRF_his, f'{FileCommon}_sechiba_history.nc' )
+if Routing == 'SIMPLE' :
+    if file_RUN_his == None : 
+        file_RUN_his = os.path.join (  dir_SRF_his, f'{FileCommon}_sechiba_history.nc' )
+        config['Files']['file_RUN_his'] = file_RUN_his
+if file_OCE_his == None :
+    file_OCE_his = os.path.join (  dir_OCE_his, f'{FileCommon}_grid_T.nc' )
+    config['Files']['file_OCE_his'] = file_OCE_his
+if file_OCE_sca == None :
+    file_OCE_sca = os.path.join (  dir_OCE_his, f'{FileCommon}_scalar.nc' )
+    config['Files']['file_OCE_sca'] = file_OCE_sca
+if file_ICE_his == None :
+    file_ICE_his = os.path.join (  dir_ICE_his, f'{FileCommon}_icemod.nc' )
+    config['Files']['file_ICE_his'] = file_ICE_his
+if file_OCE_srf == None :
+    file_OCE_srf = os.path.join (  dir_OCE_his, f'{FileCommon}_grid_T.nc' )
+    config['Files']['file_OCE_srf'] = file_OCE_srf
 
 d_ATM_his = xr.open_dataset ( file_ATM_his, use_cftime=True, decode_times=True, decode_cf=True ).squeeze()
@@ -199,10 +251,15 @@
 d_SRF_his = xr.open_dataset ( file_SRF_his, use_cftime=True, decode_times=True, decode_cf=True ).squeeze()
 d_OCE_srf = xr.open_dataset ( file_OCE_srf, use_cftime=True, decode_times=True, decode_cf=True ).squeeze()
-
-echo ( file_ATM_his )
-echo ( file_OCE_his )
-echo ( file_OCE_sca )
-echo ( file_ICE_his )
-echo ( file_SRF_his )
+if Routing == 'SECHIBA' : d_RUN_his = d_SRF_his
+if Routing == 'SIMPLE'  : d_RUN_his = xr.open_dataset ( file_RUN_his, use_cftime=True, decode_times=True, decode_cf=True ).squeeze()
+
+    
+echo ( f'{file_ATM_his = }' )
+echo ( f'{file_SRF_his = }' )
+if Routing == 'SIMPLE' : echo ( f'{file_RUN_his = }' )
+echo ( f'{file_OCE_his = }' )
+echo ( f'{file_ICE_his = }' )
+echo ( f'{file_OCE_sca = }' )
+echo ( f'{file_OCE_srf = }' )
 
 ## Compute run length
@@ -216,4 +273,8 @@
 dtime_per_sec = (dtime_per/np.timedelta64(1, "s")).values # In seconds
 dtime_per_sec = xr.DataArray (dtime_per_sec, dims=["time_counter", ], coords=[d_ATM_his.time_counter,] )
+dtime_per_sec.attrs['unit'] = 's'
+
+# Number of years
+NbYear = dtime_sec / YearLength
 
 #-- Open restart files
@@ -221,75 +282,114 @@
 YearPre = YearBegin - PackFrequency  # Year to find the tarfile of the restart of beginning of simulation
 
+config['Files']['YearPre'] = f'{YearBegin}'
+
 echo (f'Restart dates - Start : {YearRes}-12-31  /  End : {YearEnd}-12-31 ')
 
-file_restart_beg = os.path.join ( R_SAVE, 'RESTART', f'{JobName}_{YearPre}0101_{YearRes}1231_restart.tar' )
-file_restart_end = os.path.join ( R_SAVE, 'RESTART', f'{JobName}_{YearBegin}0101_{YearEnd}1231_restart.tar' )
-
-echo ( f'{file_restart_beg}' )
-echo ( f'{file_restart_end}' )
-
-file_OCE_beg = f'OCE_{JobName}_{YearRes}1231_restart.nc'
-file_OCE_end = f'OCE_{JobName}_{YearEnd}1231_restart.nc'
-file_ICE_beg = f'ICE_{JobName}_{YearRes}1231_restart_icemod.nc'
-file_ICE_end = f'ICE_{JobName}_{YearEnd}1231_restart_icemod.nc'
-
-echo ( f'{file_OCE_beg}' )
-echo ( f'{file_OCE_end}' )
-echo ( f'{file_ICE_beg}' )
-echo ( f'{file_ICE_end}' )
-
-file_ATM_beg = f'ATM_{JobName}_{YearRes}1231_restartphy.nc'
-file_ATM_end = f'ATM_{JobName}_{YearEnd}1231_restartphy.nc'
-if LMDZ :
-    file_DYN_beg = f'ATM_{JobName}_{YearRes}1231_restart.nc'
-    file_DYN_end = f'ATM_{JobName}_{YearEnd}1231_restart.nc'
-if ICO :
-    file_DYN_beg = f'ICO_{JobName}_{YearRes}1231_restart.nc'
-    file_DYN_end = f'ICO_{JobName}_{YearEnd}1231_restart.nc'
-file_SRF_beg = f'SRF_{JobName}_{YearRes}1231_sechiba_rest.nc'
-file_SRF_end = f'SRF_{JobName}_{YearEnd}1231_sechiba_rest.nc'
-liste_beg = [file_ATM_beg, file_DYN_beg, file_SRF_beg, ]
-liste_end = [file_ATM_end, file_DYN_end, file_SRF_end, ]
-echo ( f'{file_ATM_beg}')
-echo ( f'{file_ATM_end}')
-echo ( f'{file_SRF_beg}')
-echo ( f'{file_SRF_end}')
-
-if Routing == 'SIMPLE' : 
-    file_RUN_beg = f'SRF_{JobName}_{YearRes}1231_routing_restart.nc'
-    file_RUN_end = f'SRF_{JobName}_{YearEnd}1231_routing_restart.nc'
+if TarRestartPeriod_beg == None : 
+    echo (f'Restart dates - Start : {YearRes}-12-31  /  End : {YearEnd}-12-31 ')
+    TarRestartPeriod_beg = f'{YearPre}0101_{YearRes}1231'
+    config['Files']['TarRestartPeriod_beg'] = TarRestartPeriod_beg
+
+if TarRestartPeriod_end == None : 
+    YearPre = YearBegin - PackFrequency  # Year to find the tarfile of the restart of beginning of simulation
+    echo (f'Restart dates - Start : {YearRes}-12-31  /  End : {YearEnd}-12-31 ')
+    TarRestartPeriod_end = f'{YearBegin}0101_{YearEnd}1231'
+    config['Files']['TarRestartPeriod_end'] = TarRestartPeriod_end
+
+if tar_restart_beg == None :
+    tar_restart_beg = os.path.join ( R_SAVE, 'RESTART', f'{JobName}_{TarRestartPeriod_beg}_restart.tar' )
+    config['Files']['tar_restart_beg'] = tar_restart_beg
+if tar_restart_end == None :
+    tar_restart_end = os.path.join ( R_SAVE, 'RESTART', f'{JobName}_{TarRestartPeriod_end}_restart.tar' )
+    config['Files']['tar_restart_end'] = tar_restart_end
+
+echo ( f'{tar_restart_beg}' )
+echo ( f'{tar_restart_end}' )
+
+if file_ATM_beg == None : 
+    file_ATM_beg = f'{RunDir}/ATM_{JobName}_{YearRes}1231_restartphy.nc'
+    config['Files']['file_ATM_beg'] = file_ATM_beg
+if file_ATM_end == None :
+    file_ATM_end = f'{RunDir}/ATM_{JobName}_{YearEnd}1231_restartphy.nc'
+    config['Files']['file_ATM_end'] = file_ATM_end
+
+if file_DYN_beg == None :
+    if LMDZ : file_DYN_beg = f'{RunDir}/ATM_{JobName}_{YearRes}1231_restart.nc'
+    if ICO  : file_DYN_beg = f'{RunDir}/ICO_{JobName}_{YearRes}1231_restart.nc'
+    config['Files']['file_DYN_beg'] = file_DYN_beg
+    
+if file_DYN_end == None : 
+    if LMDZ : file_DYN_end = f'{RunDir}/ATM_{JobName}_{YearEnd}1231_restart.nc'
+    if ICO  : file_DYN_end = f'{RunDir}/ICO_{JobName}_{YearEnd}1231_restart.nc'
+    config['Files']['file_DYN_end'] = file_DYN_end
+    
+if file_SRF_beg == None :
+    file_SRF_beg = f'{RunDir}/SRF_{JobName}_{YearRes}1231_sechiba_rest.nc'
+    config['Files']['file_SRF_beg'] = file_SRF_beg
+if file_SRF_end == None :
+    file_SRF_end = f'{RunDir}/SRF_{JobName}_{YearEnd}1231_sechiba_rest.nc'
+    config['Files']['file_SRF_end'] = file_SRF_end
+    
+if file_OCE_beg == None : 
+    file_OCE_beg = f'{RunDir}/OCE_{JobName}_{YearRes}1231_restart.nc'
+    config['Files']['file_OCE_beg'] = file_OCE_beg
+if file_OCE_end == None :
+    file_OCE_end = f'{RunDir}/OCE_{JobName}_{YearEnd}1231_restart.nc'
+    config['Files']['file_OCE_end'] = file_OCE_end
+if file_ICE_beg == None :
+    file_ICE_beg = f'{RunDir}/ICE_{JobName}_{YearRes}1231_restart_icemod.nc'
+    config['Files']['file_ICE_beg'] = file_ICE_beg
+if file_ICE_end == None : 
+    file_ICE_end = f'{RunDir}/ICE_{JobName}_{YearEnd}1231_restart_icemod.nc'
+    config['Files']['file_ICE_end'] = file_ICE_end
+
+liste_beg = [file_ATM_beg, file_DYN_beg, file_SRF_beg]
+liste_end = [file_ATM_end, file_DYN_end, file_SRF_end]
+
+if Routing == 'SIMPLE' :
+    if file_RUN_beg == None : 
+        file_RUN_beg = f'{RunDir}/SRF_{JobName}_{YearRes}1231_routing_restart.nc'
+        config['Files']['file_RUN_beg'] = file_RUN_beg
+    if file_RUN_end == None : 
+        file_RUN_end = f'{RunDir}/SRF_{JobName}_{YearEnd}1231_routing_restart.nc'
+        config['Files']['file_RUN_end'] = file_RUN_end
+        
     liste_beg.append ( file_RUN_beg )
     liste_end.append ( file_RUN_end )
-    echo ( f'{file_RUN_beg}')
-    echo ( f'{file_RUN_end}')
+    echo ( f'{file_RUN_beg = }' )
+    echo ( f'{file_RUN_end = }' )
+
+echo ( f'{file_ATM_beg = }' )
+echo ( f'{file_ATM_end = }' )
+echo ( f'{file_DYN_beg = }' )
+echo ( f'{file_DYN_end = }' )
+echo ( f'{file_SRF_beg = }' )
+echo ( f'{file_SRF_end = }' )
+echo ( f'{file_RUN_beg = }' )
+echo ( f'{file_RUN_end = }' )
+echo ( f'{file_OCE_beg = }' )
+echo ( f'{file_OCE_end = }' )
+echo ( f'{file_ICE_beg = }' )
+echo ( f'{file_ICE_end = }' )
 
 echo ('\nExtract restart files from tar : ATM, ICO and SRF')
-for resFile in liste_beg :
-    if not os.path.exists ( os.path.join (TmpDir, resFile) ) :
-        command =  f'cd {TmpDir} ; tar xf {file_restart_beg} {resFile}'
+for resFile in liste_beg + liste_end :
+    if os.path.exists ( os.path.join (RunDir, resFile) ) :
+        echo ( f'file found : {resFile = }' )
+    else :
+        base_file = Path (file_name).stem # basename, and remove suffix
+        command =  f'cd {RunDir} ; tar xf {tar_restart_beg} {base_resFile}.nc'
         echo ( command )
-        os.system ( command )
-        
-for resFile in liste_end :
-    if not os.path.exists ( os.path.join (TmpDir, resFile) ) :
-        command =  f'cd {TmpDir} ; tar xf {file_restart_end} {resFile}'
-        echo ( command )
-        os.system ( command )
+        ierr = os.system ( command )
+        if ierr == 0 : echo ( f'tar done : {base_resFile}')
+        else         : raise Exception ( f'command failed : {command}' )
 
 echo ('\nOpening ATM SRF and ICO restart files')
-d_ATM_beg = xr.open_dataset ( os.path.join (TmpDir, file_ATM_beg), decode_times=False, decode_cf=True).squeeze()
-d_ATM_end = xr.open_dataset ( os.path.join (TmpDir, file_ATM_end), decode_times=False, decode_cf=True).squeeze()
-d_SRF_beg = xr.open_dataset ( os.path.join (TmpDir, file_SRF_beg), decode_times=False, decode_cf=True).squeeze()
-d_SRF_end = xr.open_dataset ( os.path.join (TmpDir, file_SRF_end), decode_times=False, decode_cf=True).squeeze()
-d_DYN_beg = xr.open_dataset ( os.path.join (TmpDir, file_DYN_beg), decode_times=False, decode_cf=True).squeeze()
-d_DYN_end = xr.open_dataset ( os.path.join (TmpDir, file_DYN_end), decode_times=False, decode_cf=True).squeeze()
-
-for var in d_SRF_beg.variables :
-    d_SRF_beg[var] = d_SRF_beg[var].where (  d_SRF_beg[var]<1.e20, 0.)
-    d_SRF_end[var] = d_SRF_end[var].where (  d_SRF_end[var]<1.e20, 0.)
-
-if ICO :
-    d_RUN_beg = xr.open_dataset ( os.path.join (TmpDir, file_RUN_beg), decode_times=False, decode_cf=True).squeeze()
-    d_RUN_end = xr.open_dataset ( os.path.join (TmpDir, file_RUN_end), decode_times=False, decode_cf=True).squeeze()
+d_ATM_beg = xr.open_dataset ( os.path.join (RunDir, file_ATM_beg), decode_times=False, decode_cf=True).squeeze()
+d_ATM_end = xr.open_dataset ( os.path.join (RunDir, file_ATM_end), decode_times=False, decode_cf=True).squeeze()
+d_SRF_beg = xr.open_dataset ( os.path.join (RunDir, file_SRF_beg), decode_times=False, decode_cf=True).squeeze()
+d_SRF_end = xr.open_dataset ( os.path.join (RunDir, file_SRF_end), decode_times=False, decode_cf=True).squeeze()
+d_DYN_beg = xr.open_dataset ( os.path.join (RunDir, file_DYN_beg), decode_times=False, decode_cf=True).squeeze()
+d_DYN_end = xr.open_dataset ( os.path.join (RunDir, file_DYN_end), decode_times=False, decode_cf=True).squeeze()
 
 echo ('\nExtract and rebuild OCE and ICE restarts')
